Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 6784)
@@ -30,8 +30,4 @@
 
 
-  /// <summary>
-  ///This is a test class for SimpleArithmeticExpressionInterpreter and is intended
-  ///to contain all SimpleArithmeticExpressionInterpreter Unit Tests
-  ///</summary>
   [TestClass()]
   public class SymbolicDataAnalysisExpressionTreeInterpreterTest {
@@ -55,5 +51,22 @@
 
     [TestMethod]
-    public void FullGrammarSimpleArithmeticExpressionInterpreterPerformanceTest() {
+    public void SymbolicDataAnalysisExpressionTreeInterpreterFullGrammarPerformanceTest() {
+      FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeInterpreter(), 12.5e6);
+    }
+    [TestMethod]
+    public void SymbolicDataAnalysisExpressionTreeInterpreterArithmeticGrammarPerformanceTest() {
+      FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeInterpreter(), 12.5e6);
+    }
+
+    [TestMethod]
+    public void SymbolicDataAnalysisExpressionTreeILEmittingInterpreterFullGrammarPerformanceTest() {
+      FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter(), 10e6);
+    }
+    [TestMethod]
+    public void SymbolicDataAnalysisExpressionTreeILEmittingInterpreterArithmeticGrammarPerformanceTest() {
+      FullGrammarPerformanceTest(new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter(), 10e6);
+    }
+
+    private void FullGrammarPerformanceTest(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, double nodesPerSecThreshold) {
       var twister = new MersenneTwister(31415);
       var dataset = Util.CreateRandomDataset(twister, Rows, Columns);
@@ -64,15 +77,12 @@
       grammar.MinimumFunctionDefinitions = 0;
       var randomTrees = Util.CreateRandomTrees(twister, dataset, grammar, N, 1, 100, 0, 0);
-      double[] estimation = new double[Rows];
       foreach (ISymbolicExpressionTree tree in randomTrees) {
         Util.InitTree(tree, twister, new List<string>(dataset.VariableNames));
       }
-      SymbolicDataAnalysisExpressionTreeInterpreter interpreter = new SymbolicDataAnalysisExpressionTreeInterpreter();
       double nodesPerSec = Util.CalculateEvaluatedNodesPerSec(randomTrees, interpreter, dataset, 3);
-      Assert.IsTrue(nodesPerSec > 12.5e6); // evaluated nodes per seconds must be larger than 15mNodes/sec
-    }
-
-    [TestMethod]
-    public void ArithmeticGrammarSimpleArithmeticExpressionInterpreterPerformanceTest() {
+      Assert.IsTrue(nodesPerSec > nodesPerSecThreshold); // evaluated nodes per seconds must be larger than 15mNodes/sec
+    }
+
+    private void ArithmeticGrammarPerformanceTest(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, double nodesPerSecThreshold) {
       var twister = new MersenneTwister(31415);
       var dataset = Util.CreateRandomDataset(twister, Rows, Columns);
@@ -83,11 +93,10 @@
       grammar.MinimumFunctionDefinitions = 0;
       var randomTrees = Util.CreateRandomTrees(twister, dataset, grammar, N, 1, 100, 0, 0);
-      double[] estimation = new double[Rows];
       foreach (SymbolicExpressionTree tree in randomTrees) {
         Util.InitTree(tree, twister, new List<string>(dataset.VariableNames));
       }
-      SymbolicDataAnalysisExpressionTreeInterpreter interpreter = new SymbolicDataAnalysisExpressionTreeInterpreter();
+
       double nodesPerSec = Util.CalculateEvaluatedNodesPerSec(randomTrees, interpreter, dataset, 3);
-      Assert.IsTrue(nodesPerSec > 12.5e6); // evaluated nodes per seconds must be larger than 15mNodes/sec
+      Assert.IsTrue(nodesPerSec > nodesPerSecThreshold); // evaluated nodes per seconds must be larger than 15mNodes/sec
     }
 
@@ -97,6 +106,5 @@
     ///</summary>
     [TestMethod]
-    public void SimpleArithmeticExpressionInterpreterEvaluateTest() {
-
+    public void SymbolicDataAnalysisExpressionTreeInterpreterEvaluateTest() {
       Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
         { 1.0, 1.0, 1.0 },
@@ -105,6 +113,24 @@
       });
 
-      SymbolicDataAnalysisExpressionTreeInterpreter interpreter = new SymbolicDataAnalysisExpressionTreeInterpreter();
-
+      var interpreter = new SymbolicDataAnalysisExpressionTreeInterpreter();
+      EvaluateTerminals(interpreter, ds);
+      EvaluateOperations(interpreter, ds);
+      EvaluateAdf(interpreter, ds);
+    }
+
+    [TestMethod]
+    public void SymbolicDataAnalysisExpressionILEmittingTreeInterpreterEvaluateTest() {
+      Dataset ds = new Dataset(new string[] { "Y", "A", "B" }, new double[,] {
+        { 1.0, 1.0, 1.0 },
+        { 2.0, 2.0, 2.0 },
+        { 3.0, 1.0, 2.0 }
+      });
+
+      var interpreter = new SymbolicDataAnalysisExpressionTreeILEmittingInterpreter();
+      EvaluateTerminals(interpreter, ds);
+      EvaluateOperations(interpreter, ds);
+    }
+
+    private void EvaluateTerminals(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds) {
       // constants
       Evaluate(interpreter, ds, "(+ 1.5 3.5)", 0, 5.0);
@@ -113,6 +139,46 @@
       Evaluate(interpreter, ds, "(variable 2.0 a)", 0, 2.0);
       Evaluate(interpreter, ds, "(variable 2.0 a)", 1, 4.0);
-
-
+    }
+
+    private void EvaluateAdf(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds) {
+
+      // ADF      
+      Evaluate(interpreter, ds, @"(PROG 
+                                    (MAIN 
+                                      (CALL ADF0)) 
+                                    (defun ADF0 1.0))", 1, 1.0);
+      Evaluate(interpreter, ds, @"(PROG 
+                                    (MAIN 
+                                      (* (CALL ADF0) (CALL ADF0)))
+                                    (defun ADF0 2.0))", 1, 4.0);
+      Evaluate(interpreter, ds, @"(PROG 
+                                    (MAIN 
+                                      (CALL ADF0 2.0 3.0))
+                                    (defun ADF0 
+                                      (+ (ARG 0) (ARG 1))))", 1, 5.0);
+      Evaluate(interpreter, ds, @"(PROG 
+                                    (MAIN (CALL ADF1 2.0 3.0))
+                                    (defun ADF0 
+                                      (- (ARG 1) (ARG 0)))
+                                    (defun ADF1
+                                      (+ (CALL ADF0 (ARG 1) (ARG 0))
+                                         (CALL ADF0 (ARG 0) (ARG 1)))))", 1, 0.0);
+      Evaluate(interpreter, ds, @"(PROG 
+                                    (MAIN (CALL ADF1 (variable 2.0 a) 3.0))
+                                    (defun ADF0 
+                                      (- (ARG 1) (ARG 0)))
+                                    (defun ADF1                                                                              
+                                      (CALL ADF0 (ARG 1) (ARG 0))))", 1, 1.0);
+      Evaluate(interpreter, ds,
+               @"(PROG 
+                                    (MAIN (CALL ADF1 (variable 2.0 a) 3.0))
+                                    (defun ADF0 
+                                      (- (ARG 1) (ARG 0)))
+                                    (defun ADF1                                                                              
+                                      (+ (CALL ADF0 (ARG 1) (ARG 0))
+                                         (CALL ADF0 (ARG 0) (ARG 1)))))", 1, 0.0);
+    }
+
+    private void EvaluateOperations(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds) {
       // addition
       Evaluate(interpreter, ds, "(+ (variable 2.0 a ))", 1, 4.0);
@@ -148,5 +214,5 @@
       Evaluate(interpreter, ds, "(> (variable 2.0 a) 1.9)", 0, 1.0);
       Evaluate(interpreter, ds, "(> 1.9 (variable 2.0 a))", 0, -1.0);
-      //Evaluate(interpreter, ds, "(> (sqrt -1.0) (log -1.0))", 0, -1.0); // (> nan nan) should be false
+      Evaluate(interpreter, ds, "(> (log -1.0) (log -1.0))", 0, -1.0); // (> nan nan) should be false
 
       // lt
@@ -155,5 +221,5 @@
       Evaluate(interpreter, ds, "(< (variable 2.0 a) 1.9)", 0, -1.0);
       Evaluate(interpreter, ds, "(< 1.9 (variable 2.0 a))", 0, 1.0);
-      //Evaluate(interpreter, ds, "(< (sqrt -1,0) (log -1,0))", 0, -1.0); // (< nan nan) should be false
+      Evaluate(interpreter, ds, "(< (log -1.0) (log -1.0))", 0, -1.0); // (< nan nan) should be false
 
       // If
@@ -163,5 +229,5 @@
       Evaluate(interpreter, ds, "(if 1.0 2.0 3.0)", 0, 2.0);
       Evaluate(interpreter, ds, "(if 10.0 2.0 3.0)", 0, 2.0);
-      // Evaluate(interpreter, ds, "(if (sqrt -1.0) 2.0 3.0)", 0, 3.0); // if(nan) should return the else branch
+      Evaluate(interpreter, ds, "(if (log -1.0) 2.0 3.0)", 0, 3.0); // if(nan) should return the else branch
 
       // NOT
@@ -171,4 +237,5 @@
       Evaluate(interpreter, ds, "(not 2.0)", 0, -1.0);
       Evaluate(interpreter, ds, "(not 0.0)", 0, 1.0);
+      Evaluate(interpreter, ds, "(not (log -1.0))", 0, 1.0);
 
       // AND
@@ -181,4 +248,7 @@
       Evaluate(interpreter, ds, "(and 1.0 2.0 3.0)", 0, 1.0);
       Evaluate(interpreter, ds, "(and 1.0 -2.0 3.0)", 0, -1.0);
+      Evaluate(interpreter, ds, "(and (log -1.0))", 0, -1.0); // (and NaN)
+      Evaluate(interpreter, ds, "(and (log -1.0)  1.0)", 0, -1.0); // (and NaN 1.0)
+
 
       // OR
@@ -190,4 +260,6 @@
       Evaluate(interpreter, ds, "(or -1.0 -2.0 -3.0)", 0, -1.0);
       Evaluate(interpreter, ds, "(or -1.0 -2.0 3.0)", 0, 1.0);
+      Evaluate(interpreter, ds, "(or (log -1.0))", 0, -1.0); // (or NaN)
+      Evaluate(interpreter, ds, "(or (log -1.0)  1.0)", 0, -1.0); // (or NaN 1.0)
 
       // sin, cos, tan
@@ -204,44 +276,28 @@
       Evaluate(interpreter, ds, "(log -3.0)", 0, Math.Log(-3));
 
+      // power
+      Evaluate(interpreter, ds, "(pow 2.0 3.0)", 0, 8.0);
+      Evaluate(interpreter, ds, "(pow 4.0 0.5)", 0, 1.0); // interpreter should round to the nearest integer value value (.5 is rounded to the even number)
+      Evaluate(interpreter, ds, "(pow 4.0 2.5)", 0, 16.0); // interpreter should round to the nearest integer value value (.5 is rounded to the even number)
+      Evaluate(interpreter, ds, "(pow -2.0 3.0)", 0, -8.0);
+      Evaluate(interpreter, ds, "(pow 2.0 -3.0)", 0, 1.0 / 8.0);
+      Evaluate(interpreter, ds, "(pow -2.0 -3.0)", 0, -1.0 / 8.0);
+
+      // root
+      Evaluate(interpreter, ds, "(root 9.0 2.0)", 0, 3.0);
+      Evaluate(interpreter, ds, "(root 27.0 3.0)", 0, 3.0);
+      Evaluate(interpreter, ds, "(root 2.0 -3.0)", 0, Math.Pow(2.0, -1.0 / 3.0));
+
       // mean
       Evaluate(interpreter, ds, "(mean -1.0 1.0 -1.0)", 0, -1.0 / 3.0);
 
-      // ADF      
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN 
-                                      (CALL ADF0)) 
-                                    (defun ADF0 1.0))", 1, 1.0);
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN 
-                                      (* (CALL ADF0) (CALL ADF0)))
-                                    (defun ADF0 2.0))", 1, 4.0);
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN 
-                                      (CALL ADF0 2.0 3.0))
-                                    (defun ADF0 
-                                      (+ (ARG 0) (ARG 1))))", 1, 5.0);
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN (CALL ADF1 2.0 3.0))
-                                    (defun ADF0 
-                                      (- (ARG 1) (ARG 0)))
-                                    (defun ADF1
-                                      (+ (CALL ADF0 (ARG 1) (ARG 0))
-                                         (CALL ADF0 (ARG 0) (ARG 1)))))", 1, 0.0);
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN (CALL ADF1 (variable 2.0 a) 3.0))
-                                    (defun ADF0 
-                                      (- (ARG 1) (ARG 0)))
-                                    (defun ADF1                                                                              
-                                      (CALL ADF0 (ARG 1) (ARG 0))))", 1, 1.0);
-      Evaluate(interpreter, ds, @"(PROG 
-                                    (MAIN (CALL ADF1 (variable 2.0 a) 3.0))
-                                    (defun ADF0 
-                                      (- (ARG 1) (ARG 0)))
-                                    (defun ADF1                                                                              
-                                      (+ (CALL ADF0 (ARG 1) (ARG 0))
-                                         (CALL ADF0 (ARG 0) (ARG 1)))))", 1, 0.0);
-    }
-
-    private void Evaluate(SymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds, string expr, int index, double expected) {
+      // lag
+      Evaluate(interpreter, ds, "(lagVariable 1.0 a -1) ", 1, ds.GetDoubleValue("A", 0));
+      Evaluate(interpreter, ds, "(lagVariable 1.0 a -1) ", 2, ds.GetDoubleValue("A", 1));
+      Evaluate(interpreter, ds, "(lagVariable 1.0 a 0) ", 2, ds.GetDoubleValue("A", 2));
+      Evaluate(interpreter, ds, "(lagVariable 1.0 a 1) ", 0, ds.GetDoubleValue("A", 1));
+    }
+
+    private void Evaluate(ISymbolicDataAnalysisExpressionTreeInterpreter interpreter, Dataset ds, string expr, int index, double expected) {
       var importer = new SymbolicExpressionImporter();
       ISymbolicExpressionTree tree = importer.Import(expr);
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeSimplifierTest.cs	(revision 6784)
@@ -131,13 +131,13 @@
       }
       {
-        // log transformation
-        var actualTree = simplifier.Simplify(importer.Import("(log (* (variable 2.0 a) (variable 3.0 b)))"));
-        var expectedTree = importer.Import("(+ (log (variable 1.0 a)) (log (variable 1.0 b)) 1.7918)");
-        Assert.AreEqual(formatter.Format(expectedTree), formatter.Format(actualTree));
-      }
-      {
-        // log transformation
-        var actualTree = simplifier.Simplify(importer.Import("(log (/ (variable 2.0 a) (variable 3.0 b)))"));
-        var expectedTree = importer.Import("(- (log (variable 2.0 a)) (log (variable 3.0 b)))");
+        // must not transform logs in this way as we do not know wether both variables are positive
+        var actualTree = simplifier.Simplify(importer.Import("(log (* (variable 1.0 a) (variable 1.0 b)))"));
+        var expectedTree = importer.Import("(log (* (variable 1.0 a) (variable 1.0 b)))");
+        Assert.AreEqual(formatter.Format(expectedTree), formatter.Format(actualTree));
+      }
+      {
+        // must not transform logs in this way as we do not know wether both variables are positive
+        var actualTree = simplifier.Simplify(importer.Import("(log (/ (variable 1.0 a) (variable 1.0 b)))"));
+        var expectedTree = importer.Import("(log (/ (variable 1.0 a) (variable 1.0 b)))");
         Assert.AreEqual(formatter.Format(expectedTree), formatter.Format(actualTree));
       }
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicExpressionImporter.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicExpressionImporter.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicExpressionImporter.cs	(revision 6784)
@@ -29,4 +29,5 @@
   internal class SymbolicExpressionImporter {
     private const string VARSTART = "VAR";
+    private const string LAGGEDVARSTART = "LAG";
     private const string DEFUNSTART = "DEFUN";
     private const string ARGSTART = "ARG";
@@ -58,4 +59,5 @@
     Constant constant = new Constant();
     Variable variable = new Variable();
+    LaggedVariable laggedVariable = new LaggedVariable();
     Defun defun = new Defun();
 
@@ -96,4 +98,6 @@
         if (tokens.Peek().StringValue.StartsWith(VARSTART)) {
           tree = ParseVariable(tokens);
+        } else if (tokens.Peek().StringValue.StartsWith(LAGGEDVARSTART)) {
+          tree = ParseLaggedVariable(tokens);
         } else if (tokens.Peek().StringValue.StartsWith(DEFUNSTART)) {
           tree = ParseDefun(tokens);
@@ -157,4 +161,14 @@
     }
 
+    private ISymbolicExpressionTreeNode ParseLaggedVariable(Queue<Token> tokens) {
+      Token varTok = tokens.Dequeue();
+      Debug.Assert(varTok.StringValue == "LAGVARIABLE");
+      LaggedVariableTreeNode t = (LaggedVariableTreeNode)laggedVariable.CreateTreeNode();
+      t.Weight = tokens.Dequeue().DoubleValue;
+      t.VariableName = tokens.Dequeue().StringValue;
+      t.Lag = (int)tokens.Dequeue().DoubleValue;
+      return t;
+    }
+
     private ISymbolicExpressionTreeNode CreateTree(Token token) {
       if (token.Symbol != TokenSymbol.SYMB) throw new FormatException("Expected function symbol, but got: " + token.StringValue);
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.Designer.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.Designer.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.Designer.cs	(revision 6784)
@@ -44,5 +44,4 @@
     /// </summary>
     private void InitializeComponent() {
-      this.problemView1 = new HeuristicLab.Optimization.Views.ProblemView();
       this.SamplesComboBox = new System.Windows.Forms.ComboBox();
       this.SuspendLayout();
@@ -56,14 +55,4 @@
       this.matrixView.Location = new System.Drawing.Point(3, 31);
       this.matrixView.Size = new System.Drawing.Size(304, 251);
-      // 
-      // problemView1
-      // 
-      this.problemView1.Caption = "Problem View";
-      this.problemView1.Content = null;
-      this.problemView1.Location = new System.Drawing.Point(1147, 687);
-      this.problemView1.Name = "problemView1";
-      this.problemView1.ReadOnly = false;
-      this.problemView1.Size = new System.Drawing.Size(490, 353);
-      this.problemView1.TabIndex = 1;
       // 
       // SamplesComboBox
@@ -84,8 +73,6 @@
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.SamplesComboBox);
-      this.Controls.Add(this.problemView1);
       this.Name = "ClassificationEnsembleSolutionEstimatedClassValuesView";
       this.Controls.SetChildIndex(this.matrixView, 0);
-      this.Controls.SetChildIndex(this.problemView1, 0);
       this.Controls.SetChildIndex(this.SamplesComboBox, 0);
       this.ResumeLayout(false);
@@ -95,5 +82,4 @@
     #endregion
 
-    private Optimization.Views.ProblemView problemView1;
     private System.Windows.Forms.ComboBox SamplesComboBox;
 
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationEnsembleSolutionEstimatedClassValuesView.cs	(revision 6784)
@@ -21,4 +21,5 @@
 using System;
 using System.Collections.Generic;
+using System.Drawing;
 using System.Linq;
 using System.Windows.Forms;
@@ -33,6 +34,7 @@
     ClassificationSolutionEstimatedClassValuesView {
     private const string RowColumnName = "Row";
-    private const string TargetClassValuesColumnName = "TargetVariable";
-    private const string EstimatedClassValuesColumnName = "EstimatedClassValues";
+    private const string TargetClassValuesColumnName = "Target Variable";
+    private const string EstimatedClassValuesColumnName = "Estimated Class Values";
+    private const string CorrectClassificationColumnName = "Correct Classification";
     private const string ConfidenceColumnName = "Confidence";
 
@@ -51,5 +53,8 @@
       SamplesComboBox.Items.AddRange(new string[] { SamplesComboBoxAllSamples, SamplesComboBoxTrainingSamples, SamplesComboBoxTestSamples });
       SamplesComboBox.SelectedIndex = 0;
+      matrixView.DataGridView.RowPrePaint += new DataGridViewRowPrePaintEventHandler(DataGridView_RowPrePaint);
     }
+
+
 
     private void SamplesComboBox_SelectedIndexChanged(object sender, EventArgs e) {
@@ -92,6 +97,6 @@
       int classValuesCount = Content.ProblemData.ClassValues.Count;
       int modelCount = Content.Model.Models.Count();
-      string[,] values = new string[indizes.Length, 4 + classValuesCount + modelCount];
-      double[] target = Content.ProblemData.Dataset.GetVariableValues(Content.ProblemData.TargetVariable);
+      string[,] values = new string[indizes.Length, 5 + classValuesCount + modelCount];
+      double[] target = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable).ToArray();
       List<List<double?>> estimatedValuesVector = GetEstimatedValues(SamplesComboBox.SelectedItem.ToString(), indizes,
                                                             Content.ClassificationSolutions);
@@ -102,14 +107,15 @@
         values[i, 1] = target[i].ToString();
         values[i, 2] = estimatedClassValues[i].ToString();
+        values[i, 3] = (target[i] == estimatedClassValues[i]).ToString();
         var groups = estimatedValuesVector[i].GroupBy(x => x).Select(g => new { Key = g.Key, Count = g.Count() }).ToList();
         var estimationCount = groups.Where(g => g.Key != null).Select(g => g.Count).Sum();
-        values[i, 3] = (((double)groups.Where(g => g.Key == estimatedClassValues[i]).Single().Count) / estimationCount).ToString();
+        values[i, 4] = (((double)groups.Where(g => g.Key == estimatedClassValues[i]).Single().Count) / estimationCount).ToString();
         for (int classIndex = 0; classIndex < Content.ProblemData.ClassValues.Count; classIndex++) {
           var group = groups.Where(g => g.Key == Content.ProblemData.ClassValues[classIndex]).SingleOrDefault();
-          if (group == null) values[i, 4 + classIndex] = 0.ToString();
-          else values[i, 4 + classIndex] = group.Count.ToString();
+          if (group == null) values[i, 5 + classIndex] = 0.ToString();
+          else values[i, 5 + classIndex] = group.Count.ToString();
         }
         for (int modelIndex = 0; modelIndex < estimatedValuesVector[i].Count; modelIndex++) {
-          values[i, 4 + classValuesCount + modelIndex] = estimatedValuesVector[i][modelIndex] == null
+          values[i, 5 + classValuesCount + modelIndex] = estimatedValuesVector[i][modelIndex] == null
                                                            ? string.Empty
                                                            : estimatedValuesVector[i][modelIndex].ToString();
@@ -119,5 +125,5 @@
 
       StringMatrix matrix = new StringMatrix(values);
-      List<string> columnNames = new List<string>() { "Id", TargetClassValuesColumnName, EstimatedClassValuesColumnName, ConfidenceColumnName };
+      List<string> columnNames = new List<string>() { "Id", TargetClassValuesColumnName, EstimatedClassValuesColumnName, CorrectClassificationColumnName, ConfidenceColumnName };
       columnNames.AddRange(Content.ProblemData.ClassNames);
       columnNames.AddRange(Content.Model.Models.Select(m => m.Name));
@@ -125,4 +131,5 @@
       matrix.SortableView = true;
       matrixView.Content = matrix;
+      UpdateColoringOfRows();
     }
 
@@ -150,6 +157,25 @@
     }
 
+    private void DataGridView_RowPrePaint(object sender, DataGridViewRowPrePaintEventArgs e) {
+      if (InvokeRequired) {
+        Invoke(new EventHandler<DataGridViewRowPrePaintEventArgs>(DataGridView_RowPrePaint), sender, e);
+        return;
+      }
+      bool correctClassified = bool.Parse(matrixView.DataGridView[3, e.RowIndex].Value.ToString());
+      matrixView.DataGridView.Rows[e.RowIndex].DefaultCellStyle.ForeColor = correctClassified ? Color.MediumSeaGreen : Color.Red;
+    }
 
-
+    private void UpdateColoringOfRows() {
+      if (InvokeRequired) {
+        Invoke((Action)UpdateColoringOfRows);
+        return;
+      }
+      //matrixView.DataGridView.SuspendRepaint();
+      //for (int i = 0; i < matrixView.DataGridView.Rows.Count; i++) {
+      //  bool correctClassified = bool.Parse(matrixView.Content.GetValue(i, 3));
+      //  matrixView.DataGridView.Rows[i].DefaultCellStyle.ForeColor = correctClassified ? Color.MediumSeaGreen : Color.Red;
+      //}
+      //matrixView.DataGridView.ResumeRepaint(true);
+    }
   }
 }
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionConfusionMatrixView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionConfusionMatrixView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionConfusionMatrixView.cs	(revision 6784)
@@ -114,5 +114,5 @@
         } else throw new InvalidOperationException();
 
-        double[] targetValues = Content.ProblemData.Dataset.GetEnumeratedVariableValues(Content.ProblemData.TargetVariable, rows).ToArray();
+        double[] targetValues = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable, rows).ToArray();
 
         Dictionary<double, int> classValueIndexMapping = new Dictionary<double, int>();
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionEstimatedClassValuesView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionEstimatedClassValuesView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/ClassificationSolutionEstimatedClassValuesView.cs	(revision 6784)
@@ -86,5 +86,5 @@
           string[,] values = new string[Content.ProblemData.Dataset.Rows, 5];
 
-          double[] target = Content.ProblemData.Dataset.GetVariableValues(Content.ProblemData.TargetVariable);
+          double[] target = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable).ToArray();
           double[] estimated = Content.EstimatedClassValues.ToArray();
           for (int row = 0; row < target.Length; row++) {
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationRocCurvesView.cs	(revision 6784)
@@ -107,5 +107,5 @@
 
         double[] estimatedValues = Content.GetEstimatedValues(rows).ToArray();
-        double[] targetClassValues = Content.ProblemData.Dataset.GetEnumeratedVariableValues(Content.ProblemData.TargetVariable, rows).ToArray();
+        double[] targetClassValues = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable, rows).ToArray();
         double minThreshold = estimatedValues.Min();
         double maxThreshold = estimatedValues.Max();
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionEstimatedClassValuesView.cs	(revision 6784)
@@ -51,5 +51,5 @@
           string[,] values = new string[Content.ProblemData.Dataset.Rows, 4];
 
-          double[] target = Content.ProblemData.Dataset.GetVariableValues(Content.ProblemData.TargetVariable);
+          double[] target = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable).ToArray();
           double[] estimatedClassValues = Content.EstimatedClassValues.ToArray();
           double[] estimatedValues = Content.EstimatedValues.ToArray();
Index: /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionThresholdView.cs
===================================================================
--- /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionThresholdView.cs	(revision 6783)
+++ /branches/GP.Grammar.Editor/HeuristicLab.Problems.DataAnalysis.Views/3.4/Classification/DiscriminantFunctionClassificationSolutionThresholdView.cs	(revision 6784)
@@ -32,5 +32,5 @@
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   [View("Classification Threshold")]
-  [Content(typeof(IDiscriminantFunctionClassificationSolution), true)]
+  [Content(typeof(IDiscriminantFunctionClassificationSolution), false)]
   public sealed partial class DiscriminantFunctionClassificationSolutionThresholdView : DataAnalysisSolutionEvaluationView {
     private const double TrainingAxisValue = 0.0;
@@ -135,7 +135,9 @@
     private void FillSeriesWithDataPoints(Series series) {
       List<double> estimatedValues = Content.EstimatedValues.ToList();
+      var targetValues = Content.ProblemData.Dataset.GetDoubleValues(Content.ProblemData.TargetVariable).ToList();
+
       foreach (int row in Content.ProblemData.TrainingIndizes) {
         double estimatedValue = estimatedValues[row];
-        double targetValue = Content.ProblemData.Dataset[Content.ProblemData.TargetVariable, row];
+        double targetValue = targetValues[row];
         if (targetValue.IsAlmost((double)series.Tag)) {
           double jitterValue = random.NextDouble() * 2.0 - 1.0;
@@ -150,6 +152,6 @@
       foreach (int row in Content.ProblemData.TestIndizes) {
         double estimatedValue = estimatedValues[row];
-        double targetValue = Content.ProblemData.Dataset[Content.ProblemData.TargetVariable, row];
-        if (targetValue == (double)series.Tag) {
+        double targetValue = targetValues[row];
+        if (targetValue.IsAlmost((double)series.Tag)) {
           double jitterValue = random.NextDouble() * 2.0 - 1.0;
           DataPoint point = new DataPoint();
